/* 	PIC18F4550  I2C */

 #include <htc.h>
 #include <string.h>
 
/* 	define + CONFIG1 	--> DEF. OSCILLATORE esterno 20 Mhz
	CONFIG2 			--> DEF. CANE DA GUARDIA LEGATO
	CONFIG3				--> DEF. PWM2 su RB3 + RB0..RB4 Digitali al reset + RESET su Mclr
	CONFIG4				--> DEF. Modalit DEBUG EN + LowVoltagProgramming DIS 
*/
	
  #define _XTAL_FREQ 20000000
__CONFIG(1,	HS);  			
__CONFIG(2,	WDTDIS );		
__CONFIG(3, PBDIGITAL & MCLREN);
__CONFIG(4, DEBUGEN & LVPDIS);



#include "attesa18.h"		// Routune di attesa per pic18	
#include "lcd1.c"			// Routine di INIT LCD
#include "i2c_mssp_cup.c"   // libreria I2c

//==================  SUONI e LED DI CONTROLLO ===================
#define ACCELED RD0=1
#define SPEGNILED RD0=0
#define BEEP RC0=1; attesaMs(50); RC0=0; attesaMs(50)
#define BOOP RC0=1;attesaMs(250); RC0=0; attesaMs(250)
#define LAMA RB2
/* ================  VAR GLOBALI ==============================
	- FlagProc variabile di testing da eliminare
	- stato variabile usata per cambiare stato al ROBOT
	- OstFICX DX SX sono posti a 1 se si incontra il rispettivo ostacolo
	- Mxxx parametri di lavoro ROBOT scambiati anche con gli SLAVE 
	- VBATT, MAXTEMP, TLAMA misure scambiate lo SLAVE A
	- CDM, DAT comandi e dati scambiati via RS232 tra SUPR E SLAVE
*/

	unsigned char RR=0;

// ================= Interrupt  High-priority ================
void interrupt my_isr(void){

}
// ================= Interrupt Low-priority =====================
void low_priority interrupt my_isr_low(void){

}

void initPORT(void) {
	/* == PORTA A ===  */
	TRISA = 0x00;	PORTA = 0x00;  
	TRISA = 0B00000000;
	/* == PORTA B ===   	*/
	TRISB = 0x00; 	PORTB = 0x00; 
	TRISB = 0B00000000;	
	/* == PORTA C ===  */
	TRISC = 0x00; PORTC  =0x00;
	TRISC = 0B00000000;	
	/* == PORTA D === 	*/
	TRISD = 0x00;	PORTD = 0x00;
	/* == PORTA E ===  */
	TRISE = 0x00;	PORTE = 0x00;
	TRISE = 0B00000000;
	//==================================================================
	ADCON1=0B00001111; 	// tutte le porte sono digitali pER ORA
	USBEN=0;			// disattiva USB 
	RBPU=0; 			// Pull-Up Set
}
void initOSC(void){
	// OSCCON x111 xxxx = 8Mhz : x110 xxxx = 4Mhz :Clock Interno
	// OSCCON xxxx xx00 = CONFIG OSC rimandato A __CONFIG
	OSCCON = 0b00000000;
}

// ====================   MAIN =======================
void  main(void){

	initPORT();
	initOSC();
  	lcd_init();

	I2cInitMaster();
/*	Verifica parametri di inizializzazione
	RIS=_XTAL_FREQ;
	RIS=FOSC;
	RIS=FBUS;
	RIS=BAUD;
	RIS=SLEWRATE;
	RIS=SSPCON1;
	RIS=SSPCON2;
	RIS=SSPADD; 
*/
	// All'Uscita da initMaster si ha
	// SSPCON1= 00101000 -->  xx1x xxxx= SSPEN=1 Abilita Le porte in I2C
	//					 -->  xxxx 1000= SSPM3:0 Master Mode 
	// SLEWRATE =0 --> BUS a 400 Khz
	// SSPADD = 11 --> SSPADD=FOSC/(4*400000)-1= 11,5
	lcd_clear();lcd_puts("OK");
	attesaSc(2);
	
	// === SEQUENZA DI SCRITTURA di singoli caratteri ( 4 char) =============
	I2cStart();
	if ((RR=I2cMasterOpenWrite(0x51))!=1) {lcd_clear(); lcd_puts("ERR 1");attesaSc(2);}
	if ((RR=I2cWriteMaster('A'))!=1) {lcd_clear(); lcd_puts("ERR 1");attesaSc(2);}
	if ((RR=I2cWriteMaster('B'))!=1) {lcd_clear(); lcd_puts("ERR 2");attesaSc(2);}
	if ((RR=I2cWriteMaster('C'))!=1) {lcd_clear(); lcd_puts("ERR 3");attesaSc(2);}
	if ((RR=I2cWriteMaster('D'))!=1) {lcd_clear(); lcd_puts("ERR 4");attesaSc(2);}
	I2cStop();

	//========SEQUUENZA di LETTURA di singoli caratteri (i primi 2)===============
	I2cStart();
	if ((RR= I2cMasterOpenRead(0x51))!=1) {lcd_clear(); lcd_puts("ERR 5");attesaSc(2);}
	if ((RR= I2cReadMaster(1))==255) {lcd_clear(); lcd_puts("ERR 6");attesaSc(2);}
	else {lcd_clear(); lcd_puts("D1=");lcd_putch(RR);attesaSc(2);}
	if ((RR= I2cReadMaster(0))==255) {lcd_clear(); lcd_puts("ERR 7");attesaSc(2);}
	else {lcd_clear(); lcd_puts("D2=");lcd_putch(RR);attesaSc(2);}
	I2cStop();
	
	
	/* === Scrivo una stringa LUNGA 4 e leggo una Stringa di 3 char =============
	I2cStart();
	if ((RR=I2cMasterOpenWrite(0x51))!=1) {lcd_clear(); lcd_puts("ERR 1");attesaSc(2);}
	if ((RR=I2cPutStrMaster("XYWZ",4))!=1) {lcd_clear(); lcd_puts("ERR 2");attesaSc(2);}
	I2cStop();
	unsigned char RIS[3];
	I2cStart();
	if ((RR=I2cMasterOpenRead(0x51))!=1) {lcd_clear(); lcd_puts("ERR 3");attesaSc(2);}
	if ((RR=I2cGetStrMaster(RIS,3))!=1) {lcd_clear(); lcd_puts("ERR 4");attesaSc(2);}
	else {lcd_clear(); lcd_puts(RIS);attesaSc(2);}
	I2cStop();
	*/
	while(1);
	}