/*
 *	interfaccia LCD
 *	Usa le routine di attesa.h
 *	Interfaccia LCD (Hitachi HD44780) su PORTA D
 *	Usa il modo a 4 bit
 *  RD2 = RS, RD3 = E   R/W = gnd
 *  RD4..RD7 DATI LCD DB4..DB7
 *===========================
 *  ROUTINE DISPONIBILI
 *  lcd_init();
 *  lcd_cmd(unsigned char);
 *  lcd_data(unsigned char);
 *  lcd_puts(const char * s);
 
 *  lcd_cursor(x)		
 *  lcd_clear()			
 *  lcd_goto(x)			
 *  lcd_cursor_right()	
 *  lcd_cursor_left()	
 *  lcd_display_shift()	
 *  lcd_home()			
 */

#include	<pic18.h>
#include	"lcd1.h"
// #include	"attesa18.h" Se NON INCLUSO

/* invia un comando a LCD */
void lcd_cmd(unsigned char c)
{
		LCD_WAIT; 	// attende un poco.
		LCD_DATA = (  c  & 0xF0 );
		LCD_STROBE();
    	LCD_DATA = ( (c<<4) & 0xF0 );
		LCD_STROBE();
}

/* invia un carattere a LCD */
void lcd_data(unsigned char c)
{
	LCD_WAIT; // attende un poco.
	LCD_DATA = 0;
	LCD_RS = 1;

    	LCD_DATA |= ( c & 0xF0 );      
		LCD_STROBE();
		LCD_DATA &= 0x0F;
		LCD_DATA |= ( (c<<4) & 0xF0 ); 
		LCD_STROBE();

	LCD_RS = 0;
}

/* scrive una stringa in LCD */
void lcd_puts(const char * s)
{
	while(*s)	lcd_data(*s++);
}

/* inizializza LCD */
void lcd_init()
{
		char init_value = 0x3;

	LCD_RS = 0;
	LCD_EN = 0;
	LCD_RS_TRIS	 = OUTPUT_PIN;
	LCD_EN_TRIS	 = OUTPUT_PIN;
	LCD_DATA_TRIS	 = OUTPUT_DATA;
	
	attesaMs(15);
	LCD_DATA	 = init_value;
	LCD_STROBE();				//1
	attesaMs(5);
	LCD_DATA	 = init_value;
	LCD_STROBE();				//2
	attesaUs(200);
	LCD_DATA	 = init_value;
	LCD_STROBE();				//3
	

		LCD_WAIT; 		// attende un poco.
		LCD_DATA = 0x2; // Set 4-bit mode
		LCD_STROBE();

		lcd_cmd(0x28); // Function Set

	lcd_cmd(0xF); //Display On, Cursor On, Cursor Blink
	lcd_cmd(0x1); //Display Clear
	lcd_cmd(0x6); //Entry Mode
	lcd_cmd(0x80); //Initialize DDRAM address to zero
}



