#ifndef _LCD_H_
#define _LCD_H_

/*	LCD file header */

#define LCD_WAIT attesaMs(5)

#define MESSAGE_LINE		0x0

#define LCD_RS			RD2
#define LCD_EN			RD3
#define LCD_DATA		LATD
#define LCD_DATA_PORT	PORTD 
#define LCD_RS_TRIS		TRISD2
#define LCD_EN_TRIS		TRISD3
#define LCD_DATA_TRIS	TRISD

#define OUTPUT_PIN      0x00	
#define INPUT_PIN       0x01	
#define OUTPUT_DATA     0x00	
#define INPUT_DATA      0xF0	

#define LCD_STROBE()	LCD_EN = 1; asm("nop"); asm("nop"); LCD_EN = 0

#define LCD_STROBE_READ(value)	LCD_EN = 1; \
				asm("nop"); asm("nop"); \
				value=LCD_DATA_PORT; \
				LCD_EN = 0; 

#define	lcd_cursor(x)		lcd_cmd(((x)&0x7F)|0x80)
#define lcd_clear()			lcd_cmd(0x1)
#define lcd_putch(x)		lcd_data(x)
#define lcd_goto(x)			lcd_cmd(0x80+(x));
#define lcd_cursor_right()	lcd_cmd(0x14)
#define lcd_cursor_left()	lcd_cmd(0x10)
#define lcd_display_shift()	lcd_cmd(0x1C)
#define lcd_home()			lcd_cmd(0x2)
#define lcd_line1()			lcd_cmd(0x80)
#define lcd_line2()			lcd_cmd(0xC0)
extern void lcd_cmd(unsigned char);
extern void lcd_data(unsigned char);
extern void lcd_puts(const char * s);
extern void lcd_init();

#endif

